(defgeneric translate (object x &optional y))

(defclass point ()
  ((x :initarg :x :initform 0 :accessor x)
   (y :initarg :y :initform 0 :accessor y)))

(defun make-point (&rest keys &key x y)
  (apply #'make-instance 'point keys))

(defmethod translate ((point point) x &optional (y 0))
  (setf (x point) (+ (x point) x))
  (setf (y point) (+ (y point) y))
  (values))

;; #### FIXME: not abstract.
(defclass shape ()
  ((center :initarg :center :reader center)))

(defclass circle (shape)
  ((radius :initarg :radius :reader radius)))

(defun make-circle (&key (radius 0) (x 0) (y 0) center)
  (when center
    (setq x (x center)
	  y (y center)))
  (make-instance 'circle :radius radius :center (make-point :x x :y y)))

(defmethod translate ((circle circle) x &optional (y 0))
  (translate (center circle) x y))
