(defclass player ()
  ((name :initarg :name :reader name)))

(defun make-player (name)
  (make-instance 'player :name name))

(defclass team ()
  ((players :initform nil)))

(defun make-team ()
  (make-instance 'team))

;; #### NOTE: SIZE is a regular function.
(defun size (team)
  (length (slot-value team 'players)))

;; #### NOTE: HIRE is a regular function.
(defun hire (human team)
  (pushnew human (slot-value team 'players))
  (values))

;; #### NOTE: FIRE is a regular function.
(defun fire (human team)
  (setf (slot-value team 'players)
	(delete human (slot-value team 'players)))
  (values))


#|

(defvar *team* (make-team))
(size *team*) ;; => 0

(hire (make-player "John") *team*)
(size *team*) ;; => 1

(defvar *dave* (make-player "Dave"))
(hire *dave* *team*)
(size *team*) ;; => 2

(fire *dave* *team*)
(size *team*) ;; => 1

(fire *dave* *team*)
(size *team*) ;; => 1

|#
